local router = require("router")

if (ngx.var.uri == '/network/wan/pppoe/dial') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/wan_pppoe_dial.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.set_wan_method(1)
		router.write_config("/etc/router/config/wan_pppoe_dial.json", "/etc/router/scripts/start_wan.sh")
	end
elseif (ngx.var.uri == '/network/wan/pppoe/multidial') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/wan_pppoe_multidial.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.set_wan_method(2)
		router.write_config("/etc/router/config/wan_pppoe_multidial.json", "/etc/router/scripts/start_wan.sh")
	end
elseif (ngx.var.uri == '/network/wan/pppoe/multiwan') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/wan_pppoe_multiwan.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.set_wan_method(3)
		router.write_config("/etc/router/config/wan_pppoe_multiwan.json", "/etc/router/scripts/start_wan.sh")
	end
elseif (ngx.var.uri == '/network/wan/dhcp') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/wan_dhcp.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.set_wan_method(4)
		router.write_config("/etc/router/config/wan_dhcp.json", "/etc/router/scripts/start_wan.sh")
	end
elseif (ngx.var.uri == '/network/wan/static') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/wan_static.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.set_wan_method(5)
		router.write_config("/etc/router/config/wan_static.json", "/etc/router/scripts/start_wan.sh")
	end
elseif (ngx.var.uri == '/network/wan/bridge') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/wan_bridge.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.set_wan_method(6)
		router.write_config("/etc/router/config/wan_bridge.json", "/etc/router/scripts/start_wan.sh")
	end
elseif (ngx.var.uri == '/network/wan/method') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/wan_method.json")
	end
elseif (ngx.var.uri == '/network/wireless/2g') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/wireless_2g.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.write_config("/etc/router/config/wireless_2g.json", "/etc/router/scripts/start_wireless_2g.sh")
	end
elseif (ngx.var.uri == '/network/wireless/5g') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/wireless_5g.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.write_config("/etc/router/config/wireless_5g.json", "/etc/router/scripts/start_wireless_5g.sh")
	end
elseif (ngx.var.uri == '/network/lan/gateway') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/lan_gateway.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.write_config("/etc/router/config/lan_gateway.json", "/etc/router/scripts/start_lan.sh")
	end
elseif (ngx.var.uri == '/network/lan/dhcp') then
	if (ngx.var.request_method == 'GET') then
		router.read_config("/etc/router/config/lan_dhcp.json")
	elseif (ngx.var.request_method == 'PUT') then
		router.write_config("/etc/router/config/lan_dhcp.json", "/etc/router/scripts/start_lan.sh")
	end
elseif (ngx.var.uri == '/network/lan/devices') then
	if (ngx.var.request_method == 'GET') then
		local cjson = require("cjson")
		local devices = {}
		setmetatable(devices, cjson.empty_array_mt)
		local file = io.open("/etc/router/tmp/dnsmasq.leases", "r");
		for str in file:lines() do
			local macaddr, ipaddr, devname = string.match(str, "^[%d]+%s([%x:]+)%s([%d.]+)%s([^%s]+)")
			local device = {}
			device["devname"] = devname
			device["ipaddr"] = ipaddr
			device["macaddr"] = macaddr
			table.insert(devices, device)
		end
		local resp = cjson.encode(devices)
		ngx.say(resp)
	end
elseif (ngx.var.uri == '/network/lan/device/status') then
	if (ngx.var.request_method == 'GET') then
		local cjson = require("cjson")
		local ipaddr = ngx.var.arg_ipaddr
		if (ipaddr == nil) then
			router.process_error(5, "server get url args failed!")
			return
		end
		local online = 0
		local os_ret = os.execute("arping -c 1 "..ipaddr)
		if (os_ret == true) then
			online = 1
		end
		local temp = {}
		temp["ipaddr"] = ipaddr
		temp["online"] = online
		local resp = cjson.encode(temp)
		ngx.say(resp)
	end
else
	router.process_error(1, "invalid uri: "..ngx.var.uri)
end
